#include <iostream>

using namespace std;

class Kredit {
	long summe;
	double effZins;
	int monate;
	long brutto;
	long zinsen;
	long erlassen;

	long Restschuld (long Rate);

	long rate()
	{
		long rate = (double)summe/monate; // Anfangswert keine Zinsen
		
		long rest;
		while (1) {
			rest = Restschuld(rate+1);
			if (rest < 0) break;
			rate += 1;
		}
		erlassen = Restschuld(rate);
		return rate;
	}

	void outMark(long a)
	{
		cout << a/100 <<'.'<<a%100;
	}
	
public:
	Kredit (long S, double Eff, int M)
		:summe(100*S), effZins(Eff), monate(M), zinsen(0) {}

	void calculate() 
	{
		long Rate = rate();

		cout<<"Bruttokreditsumme: ";
		outMark(monate*Rate);
		cout<<endl<<"Rate ";
		outMark(Rate);
		cout<<endl;
	}

// nicht verlangt:
	void Plan()
	{
		long Rate = rate();
		long Z = 0;
		long offen = summe;
	
		for (int m=1; m<=monate; ++m)
		{
			Z += (offen*effZins/1200+0.5);
			
			cout << m << ".Monat: noch zu zahlen ";
			outMark(offen);
			cout <<" Zinsen ";
			outMark(Z);
			cout<<endl;

			offen -= Rate;
			if (!(m%12) // Jahresabschluss
				||
				m == monate // letzte Rate
				)
			{
				offen += Z;
				zinsen += Z;
				Z = 0;
			}
		}
		cout<<"\n\nBruttokreditsumme: ";
		outMark(summe+zinsen-erlassen);
		cout<<endl<<"Rate ";
		outMark(Rate);
		cout<<endl;
	}
};

long Kredit::Restschuld(long Rate)
{
	long Z = 0;
	long offen = summe;
	
	for (int m=1; m<=monate; ++m)
	{
		Z += (offen*effZins/1200+0.5);
		offen -= Rate;
		if (!(m%12) // Jahresabschluss
			||
			m == monate // letzte Rate
			)
		{
			offen += Z;
			Z = 0;
		}
	}
	return offen;
}

int main()
{
	Kredit k(17000, 4.9, 48);

//	k.Plan();
	k.calculate();
}
		
	
		
		
	
