#include <iostream>
#include <stdlib>

void out (char c1, char c2)
{
	cout <<c1<<"-->"<<c2<<endl;
}

void hanoi (int n, char from, char via, char to)
{
	if (n==1) { out (from, to); return; }
	hanoi (n-1, from, to, via);
	out (from, to);
	hanoi (n-1, via, from, to);
}

int main(int argc, char** argv)
{
	if (argc<2) {cout<<"Argument fehlt\n"; return -1;}
	int n=atoi(argv[1]);
	hanoi(n, 'A', 'B', 'C');
}

	
	

