#include <iostream.h>

class X {
	static void p(const char* s) { cout<<"X::"<<s<<endl; }
public:
	X()		{p("X()");}
	X(int)		{p("X(int)");}
	X(const X&)		{p("X(constX&)");}
	~X()		{p("~X()");}
};

X x1, x2=2, x3=x2;		
				
X x4();	 // ist eine Funktionsdeklaration !!
				
X  f (X x) {return x;}		
X& g (X& x){return x;}		
				
int main()
{
	cout<<"start\n";
	X x5 (2);
	X* px=new X;
	{
		x1=f(x5);
	}
	x2=g(*px);
	cout<<"end\n";
}


/* 
X::X()			-	x1
X::X(int)		-	x2 
X::X(constX&)		-	x3
start	
X::X(int)		-	x5
X::X()			-	*px
X::X(constX&)		-	Kopie von x5 an f-lokales X 
X::X(constX&)		-	Kopie des f-lokalen X an tmp. X
X::~X()			-	beide Kopien im
X::~X()			-	lokalen Block
end
X::~X()			-	x5
X::~X()			-	x3
X::~X()			-	x2
X::~X()			-	x1
*/
