#include <iostream.h>

class BtreeNode {
	int n;
	BtreeNode * left, *right;
	static BtreeNode* root;
	void insert (BtreeNode* & = root);
public:
	BtreeNode(int);
	static void out(BtreeNode* = root);
};

BtreeNode* BtreeNode::root=0;

BtreeNode::BtreeNode(int p): n(p), left(0), right(0)
{
	insert ();
}

void BtreeNode::out(BtreeNode* r)
{
	if (r) {
		if (r->left)  out (r->left);
		cout << r->n << endl;
		if (r->right) out (r->right);
	}
}


void BtreeNode::insert (BtreeNode* & r)
{
	if (!r)  { r=this; return; }
	
	if (n<=r->n) insert (r->left);
	else	     insert (r->right);
}

main()
{
	int n;

	do {
		cin>>n;
		new BtreeNode(n);
	} while (n);

	BtreeNode::out();
}
