#include "StackImpl.h"

//---- Stack -----------------------------------------------------------
class Stack{
protected:
	StackImpl* rep;
	Stack(const Stack& other); // no copy allowed
public:
	Stack(int dim=100): rep(new StackImpl(dim)) { }
	~Stack() 		{ delete rep; }
	void push (int i)	{ rep->push(i); }
	int pop()		{ return rep->pop(); }
	int full()		{ return rep->full(); }
	int empty()		{ return rep->empty(); }
	void print()		{ rep->print(); }
};

