#ifdef __GNUG__
#  pragma implementation
#endif

#include "StackImpl.h"
#include <stdlib.h>
#include <iostream.h>


class StackElement {
	int val;
	StackElement* nxt;
public:
	StackElement(int i, StackElement* top): val(i), nxt(top){}
		
	StackElement* next() {return nxt;}
	int value() {return val;}
};

//---- Stack ---------------------------------------------------------

	
StackImpl::~StackImpl()
{
	while(top) pop();
}

void StackImpl::push (int i)
{
	top=new StackElement(i,top);
}

int StackImpl::pop ()
{
	StackElement* p=top;
	int i=p->value();
	top=p->next();
	delete p;

	return i;
}

void StackImpl::print()
{
	for (StackElement* p=top; p; p=p->next())
		cout<<p->value()<<endl;
}

