#include <iostream.h>

class X {
	int i;
	X(int n):i(n){}
	friend class factoryX;
	X(const X& x):i(x.i) {};
public: 
	void print ()
	{
		cout<<"an X at "<< this <<endl;
	}
};

class factoryX {
public:
	static X* create (int i) { if (i>0) return new X(i);
					else return 0; }
	static X* create (const X& other) {return new X(other);}
	static void destroy (X* p) { delete p; }
};

// X x=1; // should be not allowed

void f(X x){x.print();}

int main()
{
//	X xx=2; // should be not allowed

	X* xxx = factoryX::create (1);

	if (xxx) 
	{
		xxx->print();
		factoryX::destroy(xxx);
	}	
	else cout<<"no X created\n";

	xxx = factoryX::create (-1);
	if (xxx)
	{
		xxx->print();
		factoryX::destroy(xxx);
	}
	else cout<<"no X created\n";
		
//	f(*xxx); // should be not allowed
	
}

