#include <stdio.h>
#include <string.h>

class L {
	char* const name;
	static L s;
	static int c;
	static L* const sentinel;
	L* suc, *pred;
	L():name(0),suc(this),pred(this){}
public:
	L(const char* n): 	name(new char[strlen(n)+1]),
				pred(sentinel), suc(sentinel->suc)
	{
		strcpy(name, n);
		sentinel->suc->pred=this;
		sentinel->suc=this;		
	}
	
	L(const L& l): 	name(new char[strlen(l.name)+3]),
				pred(sentinel), suc(sentinel->suc)
	{
		sprintf(name, "%s%d", l.name, c++);
		sentinel->suc->pred=this;
		sentinel->suc=this;		
	}
		
	~L()
	{
		delete [] name;
		suc->pred=pred;
		pred->suc=suc;
	}

	static void out(){	
		for (L* l = sentinel->suc; l!=sentinel; l=l->suc) 
			printf("%s\n", l->name); 
	}
};

L L::s;
L* const L::sentinel=&s;
int L::c=0;

class A: public L {public: A(const char*n):L(n){}};
class B: public L {public: B(const char*n):L(n){}};
class C: public L {public: C(const char*n):L(n){}};
class D: public L {public: D(const char*n):L(n){}};
class E: public L {public: E(const char*n):L(n){}};
class F: public L {public: F(const char*n):L(n){}};

A a("luise");

int main() {
L::out();
	A l1=a;
L::out();
	{
L::out();
		B l2("willi");
L::out();
		C l3("martha");
L::out();
		{
L::out();
			D l4("siegfried");
L::out();
		}
L::out();
		E l5("emma");
L::out();
	}
L::out();
	F l6("detlef");
L::out();
	F* f=new F("eduard");
L::out();
}

