#include <iostream.h>
#include <string.h>


class String {
	class StringRep {
	char *rep;
	int ref;

	StringRep (const char* s):rep(new char [strlen(s)+1]), ref(1)
	{
		strcpy (rep, s);
		cout << "StringRep (const char*):"
			<<" rep="<<rep<<endl;
	}

	~StringRep()
	{
		delete rep;
		cout << "~StringRep ():"
			<<" rep="<<rep<<endl;

	}
	friend class String;
	} * rep;
		
public:
	String (const char* s):rep(new StringRep(s)) {
	cout<<"String(const char*): "<<" rep at "<<rep<<endl;
}
	
	String (const String& other)
	{
		rep=other.rep;
		rep->ref++;
		cout<<"String(const String&): "<<" rep at "<<rep
			<<" rep->ref="<<rep->ref<<endl;
	}
	
	~String ()
	{
		if (!--rep->ref) delete rep;
		cout<<"~String ()"<<" rep->ref="<<rep->ref<<endl;
	}

	String & operator= (const String& other)
	{
		if (this==&other) return *this;
		if (!--rep->ref) delete rep;
		rep=other.rep;
		rep->ref++;
		cout<<"String& operator= (const String&)"
			<<" rep->ref="<<rep->ref<<endl;

		return *this;
	}
};

main ()
{
cout<<"------------------\n";
	String *s1 = new String ("ABC");
cout<<"------------------\n";
	{
		String s2=*s1;
cout<<"------------------\n";
		String s3 ("XYZ");
cout<<"------------------\n";
		s3=s2;
cout<<"------------------\n";
	}
cout<<"------------------\n";
	delete s1;
cout<<"------------------\n";
}

	
		
		
		
