#include <iostream.h>
#include <time.h>

class X {
	char x [2000];
public:	int i;
	X(int n): i(n){}
};

int middle1 (X a, X b)
{
	return (a.i+b.i)/2 ;
}

int middle2 (const X& a, const X& b)
{
	return (a.i+b.i)/2 ;
}

inline int middle3 (const X& a, const X& b)
{
	return (a.i+b.i)/2 ;
}

inline int middle4 (const X& a, const X& b)
{
	return (a.i+b.i)>>1 ;
}



main()
{
  	clock_t start, end;
	
	int i;
	X a(123), b(345);

	i = 100000;
	start = clock();
	while (i--) middle1 (a, b);
	end = clock ();
	cout << end - start << endl;

	i = 100000;
	start = clock();
	while (i--) middle2 (a, b);
	end = clock ();
	cout << end - start << endl;

	i = 100000;
	start = clock();
	while (i--) middle3 (a, b);
	end = clock ();
	cout << end - start << endl;

	i = 100000;
	start = clock();
	while (i--) middle4 (a, b);
	end = clock ();
	cout << end - start << endl;

}
