#include <iostream.h>
#include "BinaryTree.h"

class BNode {
	friend BinaryTree;
	BNode *left, *right;
	int val;
	BNode(int i):val(i), left(0), right(0) {}
	static void into (BNode* r, int i)
	{
		if (i<=r->val) 
			if (r->left) into(r->left, i);
			else
			   r->left=new BNode(i);
		else
			if (r->right) into(r->right, i);
			else
			   r->right=new BNode(i);
	}
	friend ostream& operator << (ostream& o, const BNode& n)
	{
		if (n.left) o<<*n.left;
		o<<n.val<<' ';
		if (n.right) o<<*n.right;
		return o;
	}
};
	
void BinaryTree::operator +=(int i)
	{
		if (root) BNode::into (root, i);
		else root=new BNode(i);
	}

ostream& operator << (ostream& o, const BinaryTree& t)
	{
		return o<<*t.root;
	}



