#ifndef __COMPLEX_H__
#define __COMPLEX_H__

#include <iostream.h>

class Complex {
	double real, imag;
public:
	friend Complex operator + (const Complex&, const Complex&);
	friend Complex operator - (const Complex&, const Complex&);
	friend Complex operator * (const Complex&, const Complex&);
	friend Complex operator / (const Complex&, const Complex&);

	friend ostream& operator << (ostream&, const Complex&);
	friend istream& operator >> (istream&, Complex&);

	Complex(double r=0, double i=0):real(r), imag(i) {}
};

#endif
