#include <iostream.h>

#define VIRTUAL /*<----*/

#ifdef VIRTUAL
#define virtual virtual
#else
#define virtual
#endif

#define BODY(X,I)\
	int i;\
public:\
	X():i(I)		{ cout<<' '<<#X<<"(): "; foo(); }\
	~X() 		{ cout<<'~'<<#X<<"(): "; foo(); }\
	virtual void foo(){cout<<#X<<"::foo(), i=="<<i<<endl;}

class A { BODY(A,1) };
class B: public A { BODY(B,2) };
class C: public B { BODY(C,3) };

void bar(A& r){cout<<"bar():\t"; r.foo();}

main() {
	{ 	A a; bar(a);
		{	B b; bar(b); }
 	}
 	C c; bar(c);
}

/*
mit <---- :

 A(): A::foo(), i==1
bar():	A::foo(), i==1
 A(): A::foo(), i==1
 B(): B::foo(), i==2
bar():	B::foo(), i==2
~B(): B::foo(), i==2
~A(): A::foo(), i==1
~A(): A::foo(), i==1
 A(): A::foo(), i==1
 B(): B::foo(), i==2
 C(): C::foo(), i==3
bar():	C::foo(), i==3
~C(): C::foo(), i==3
~B(): B::foo(), i==2
~A(): A::foo(), i==1


ohne <---- :

 A(): A::foo(), i==1
bar():	A::foo(), i==1
 A(): A::foo(), i==1
 B(): B::foo(), i==2
bar():	A::foo(), i==1
~B(): B::foo(), i==2
~A(): A::foo(), i==1
~A(): A::foo(), i==1
 A(): A::foo(), i==1
 B(): B::foo(), i==2
 C(): C::foo(), i==3
bar():	A::foo(), i==1
~C(): C::foo(), i==3
~B(): B::foo(), i==2
~A(): A::foo(), i==1

*/
