#include <iostream>

class Gefaess {
	double pKaffee;
	double pMilch;
	double menge;
public:
	Gefaess(double pK, double pM, double m):
		pKaffee(pK), pMilch(pM), menge(m){}
	virtual void stat() {
		cout<<menge<<"ml, davon "<<pKaffee
		    <<"% Kaffee "<<pMilch<<"% Milch\n";
	}
	Gefaess & operator- (Gefaess& g)
	{
		g.pKaffee=pKaffee;
		g.pMilch =pMilch;
		menge-=g.menge;
		return g;
	}

	Gefaess & operator+ (Gefaess& g)
	{
		double Kaffee=menge*pKaffee+g.menge*g.pKaffee;
		double Milch =menge*pMilch+g.menge*g.pMilch;
		menge+=g.menge;
		pKaffee=Kaffee/menge;
		pMilch=Milch/menge;
		return *this;
	}

	
};

class Tasse : public Gefaess {
public:
	Tasse (double pK, double pM):Gefaess(pK, pM, 100){}
	void stat() {
		cout<<"Die Tasse enthaelt ";
		Gefaess::stat();
	}
};

class Loeffel : public Gefaess {
public:
	Loeffel (double pK=0, double pM=0):Gefaess(pK, pM, 5){}
	void stat() {
		cout<<"Der Loeffel enthaelt ";
		Gefaess::stat();
	}
};

class Tasse_voll_Milch : public Tasse {
public:
	Tasse_voll_Milch():Tasse (0, 100){}
};

class Tasse_voll_Kaffee : public Tasse {
public:
	Tasse_voll_Kaffee():Tasse (100, 0){}
};


int main() {
	Gefaess& K = *new Tasse_voll_Kaffee;
	Gefaess& M = *new Tasse_voll_Milch;
	Gefaess& L = *new Loeffel;

	L=K-L;	
	M=M+L;

	L=M-L;
	K=K+L;

	K.stat();
	M.stat();
}

/*
Die Tasse enthaelt 100ml, davon 95.2381% Kaffee 4.7619% Milch
Die Tasse enthaelt 100ml, davon 4.7619% Kaffee 95.2381% Milch
*/

