#include <iostream>

using std::cout;

void out(int i=0){i?cout<<i:cout<<'-'; 
#ifdef DEBUG
			cout<<endl;
#endif
}

#ifdef DEBUG
void t(const char* c){cout<<c<<endl;}
#else
#define t(XXX) /*empty*/
#endif


class A {
	int n;
public:
	A(int i=3):n(i){t("A::A()");out(i);f();}
	A(const A& o){t("A::A(const A&"); out(n=o.n);}
	~A(){t("A::~A()"); out(n);}
	virtual void f(){t("A::f()"); out(++n);}
} a;

class B : public virtual A {
	int n;
public:
	B(int i=5):n(i), A(i+1){t("B::B()"); out(i);}
	~B(){t("B::~B()"); out(n);}
	void f(){t("B::f()"); out(n--);}
} b;

class C: public virtual A {
public:
	C():A(7){t("C::C()"); out();}
	~C(){t("C::~C()"); out();}
} c;

class D: public B, public C {};

int main()
{
t("anfang von main");
	A * p;

t("es folgt: p=&a; p->f();");
	p=&a; p->f();
t("es folgt: p=&b; p->f();");
	p=&b; p->f();
t("es folgt: p=&c; p->f();");
	p=&c; p->f();

t("es folgt: p=new D; p->f();");
		p=new D; p->f();

t("es folgt: delete p;");
	delete p;

t("es folgt: C* q = new D;");
	C* q = new D;
t("es folgt: q->f();");
	q->f();
t("es folgt: delete q;");
	delete q;

t("ende von main");
}	
/*

g++ 2.95:
3467578-559345-54345-5-4-9475
CC 5.0:
3467578-559345-54345-5-4-9475

*/
