#include <iostream>
#include <cstdio>

#define DEBUG 1

using std::cout;
using std::endl;

class Int{
    int value;
    char *str;
// a)
//  Int(const Int&);
  public:
// b)
    Int(const Int& i):value(i.value), str(0)
    {
	if (i.str)
	{
		str = new char[10];
		if (DEBUG) cout<<"+";
		strcpy(str, i.str);
	}
    }

    Int(int v):value(v),str(0){}

    char* toString() {
      if(!str){
        str = new char[10];
	if (DEBUG) cout<<"+";
        sprintf(str,"%d",value);
      }
      return str;
    }


    ~Int(){
      if (str) 
      {
	if (DEBUG) cout<<"-";
      	delete []str;
      }
    }
};

int main(){
  Int x(12379);
  
  cout<<x.toString()<<endl;  

  Int y = x;
  

  cout<<y.toString()<<endl;


}
