#include <iostream.h>

#define DIM 3

typedef double M3x3 [DIM][DIM];

void out(M3x3);

double det (M3x3 m)
{
	if (m[0][0]==0)
	{
		if (m[1][0]!=0) 
		{
			double n[DIM]={m[0][0], m[0][1], m[0][2]};
			for (int i=0; i<DIM; ++i)
			{
				m[0][i]=m[1][i];
				m[1][i]=n[i];
			}
		}
		else 
		if (m[2][0]!=0) 
		{
			double n[DIM]={m[0][0], m[0][1], m[0][2]};
			for (int i=0; i<DIM; ++i)
			{
				m[0][i]=m[2][i];
				m[2][i]=n[i];
			}
		}
		else return 0;
	}

	for (int row=1; row<DIM; ++row)
	{
	   double n[DIM]={m[row][0], m[row][1], m[row][2]};
	   for (int col=0; col<DIM; ++col)
		  m[row][col]=n[col]-n[0]*m[0][col]/m[0][0];
	}
	return m[0][0]*(m[1][1]*m[2][2]-m[1][2]*m[2][1]);
}

void out (M3x3 m)
{
	for (int row=0; row<DIM; row++)
	{
	   for (int col=0; col<DIM; col++)
	   	cout<<"   "<<m[row][col];
	   cout<<endl;
	}
}

	
// M3x3 m={1.234,2.345,3.456,4.567,9.46523,6.246,7.2463,8.435,5.546};

int main()
{
	M3x3 m;
	
	for (int i=0; i<DIM;++i)
	   for (int j=0; j<DIM;++j)
		cin>>m[i][j];

	out(m);

	cout<<det(m);

}
	

