	#include <iostream.h>
	#include /*1*/"stdlib.h"

	#ifdef HAS_NO_BOOL
	typedef /*2*/ int bool;
	const true=1;/*3*/
	const false=0;/*4*/
	#endif

	class Prime {
		long v; /*5*/	// the prime value
		Prime* nxt;/*6*/	// the next Prime 
		Prime ();	// calculates next Prime in next()
		Prime (long l): v(l), nxt(0) {/*7*/}  // only once (for 2) called 
		static long last_known;  // the last prime calculated so far
		static bool isPrime (long n); 
	public:
		static Prime *first;
		Prime* next();
		long val(){return v;}
	};/*8*/

	bool Prime::/*9*/isPrime(long n)
	{
		Prime* /*10*/ p=first;
		long f;
		for (;;)
		{	f=p->val(); /*11*/
			if (/*12*/!(n%f)) return /*13*/false; // no prime
			p=p->nxt /*14*/; 
			if (p && p->val() < n/2) continue;
			else return true; 
		}
	}

	Prime* Prime::next()
	{
		// if there is no next prime 
		// the next one is created 
		return nxt ? nxt : ( nxt = new Prime() );
	}

	Prime::Prime():nxt(0)
	{
		v=last_known/*15*/;
		do ++v;/*16*/ while ( ! isPrime(v) );
		/*17*/last_known=v;
		//cout<<"up to "<<v<<endl;
	}

	long Prime::last_known = 2;	
	Prime* Prime::first=new Prime(Prime::last_known);

	void factorial (long n) // strstr
	{
		Prime /*18*/*p=Prime::first;
		long f=p->val();
		while (f <= n)
		{	
			if (!(n % f)) // is f a factor ?
			{
				cout<<'\t'<<f<<endl;
				factorial(n/f);
				return;/*19*/
			}
			else // try the next prime
				f = (p=p->next())->val();/*20*/
			/*21*/ //}
		}
	}

	int main(int n, /*22*/ char* p[]/*23*/ /*24*/ )  
	{
		{
			{
				long n=atol(p[/*25*/1]);
				cout<<n<<endl;
				/*26*/ /*Prime::*/ factorial(n);
			}
		}
	}
