#include <assert.h>
#include <iostream.h>
#include <string.h>

const char* my_strstr (const char *s1, const char *s2)
{
	if (!*s2) return s1; // s2 empty

	const char *p1=s1;
	const char *start=0;
	while (1)
	{
		const char *p2=s2;
		while (*p1!=*p2) 
		{
			p1++;
			if (!*p1) return 0;
		}
//		assert (*p1==*p2);
		start=p1;
		while (*p1==*p2)
		{
			p1++; p2++;
			if (!*p2) return start;
		}
	}
}
 
int main()
{
	char s1[]="1234567891234567891234567891234567891234567891234367891234";
	char s2[]="12343";
	const char *s;

	cout<<"mystrstr: "<<endl;
	for (int i=0; i<1000000; ++i) my_strstr(s1, s2);
	cout<<"ready\n";

	cout<<"strstr: "<<endl;
	for (int i=0; i<1000000; ++i) strstr(s1, s2);
	cout<<"ready\n";
}

/* check with optimization turned off and on */
		
