#include <iostream>
#include <cassert>

using namespace std;

// track timer:

class TT {
	int hour, min, sec;
public:
	TT():hour(0), min(0), sec(0){}
	TT& add (int m, int s, int delay=0)
	{
		assert (m<60);
		assert (s<60);
		sec+=delay+s;
		while (sec>=60){sec-=60; ++min;}
		min+=m;
		if (min>=60){min-=60; ++hour;}
		return *this;
	}

	double length() // in minutes
	{
		return hour*60+min+double(sec)/60;
	}
};

int main()
{
	// Dire Straits: Money for Nothing

	TT t;
	t.add(5,46)	// Sultans of Swing
	 .add(4,0);	// Down to the waterline
	t.add(4,33);	// Portobello Belle
	t.add(3,30);	// Twisting by the Pool
	t.add(8,9);	// Tunnel of Love
	t.add(3,31);	// Where do you think you're going
	t.add(4,07);	// Wak of Life
	t.add(5,48);	// Private Investigations
	t.add(12,00);	// Telegraph Road
	t.add(4,05);	// Money for Nothing
	t.add(4,48);	// Brothers in Arms
	
	cout<<"Gesamtlaenge: "<<t.length()<<" minuten"<<endl;
}
