#include <iostream>

using namespace std;

class Fahrenheit;

class Celsius {
	double val;
public:
	Celsius(double t): val(t){}
	operator Fahrenheit();
	friend ostream& operator<< (ostream& o, Celsius c)
	{
		return o<<c.val<< "\260C";
	}
};

class Fahrenheit {
	double val;
public:
	Fahrenheit(double t): val(t){}
	operator Celsius()
	{
		return Celsius((val-32)*5/9);
	}
	friend ostream& operator<< (ostream& o, Fahrenheit f)
	{
		return o<<f.val<< "\260F";
	}
};

Celsius::operator Fahrenheit()
{
	return Fahrenheit(9*val/5+32);
}

main()
{
	Celsius c = 20;
	Fahrenheit f = 100;

	cout << c << " = " << Fahrenheit(c) << endl  
	     << f << " = " << Celsius(f) << endl;
}

	
