#ifndef __VEKTOR_H__
#define __VEKTOR_H__

#include <iostream.h>


class Vektor {
	double *data;
	int n;
public:
	Vektor (int dim);	// legt einen Vektor der Dimension n an
				// alle Elemente sind mit 0 initialisiert
	Vektor (const Vektor&); // Kopie
	double& operator[](int);	// Vektorelement am Index n 
					// (sofern existent)
	friend double operator* (const Vektor&, const Vektor&);
	friend ostream& operator<< (ostream&, const Vektor&);
	Vektor& operator=(const Vektor&);		
};

#endif
