#include <iostream.h>

const dim=1000;

int primes[dim];

int 
prim (int n)
{
	if (n < 2) return 0;
	for (int i=2; i<=n/2; i++)
		if (!(n%i)) return 0;
	return 1;
}

void
init_primes()
{
	int n=2;
	for (int i=0; i<dim; ++i)
	{
		while (!prim(n)) n++;
		primes[i]=n;
		n++;
	}
}


int try2(int n)
{
	int k;

	for (int i=0; i<dim; ++i)
	         if (((k=primes[i])<n) && prim(n-k))
		 {
			cout << n << " = " << primes[i] << " + "
			     << n-k <<endl;
			return 1;
		 }
	return 0;
}

main()
{
	init_primes();
	for (int n=6; n<=dim; n+=2) 
		if (! try2(n)) 
			cout << n << " nicht als Summe zweier Primzahlen"
			     << " darstellbar\n";

}
		
	

	
