#include <iostream>
#include "Timer"

int main()
{
	Timer t;
	
	t.start();
	
	int n=3;	
	for(int i=0; i<10000000; ++i) n*=3;
	
	t.stop();
	
	cout<<"int: "<<"["<<n<<"] "<< t.millisec() <<"ms"<<endl;
	
	t.start();
	
	double d=1;	
	for(int i=0; i<10000000; ++i) d*=1.0000001;
	
	t.stop();
	
	cout<<"double: "<<"["<<d<<"] "<< t.millisec() <<"ms"<<endl;
}	

/*
g++ ohne Optimierung:
int: [1587566083] 1850ms
double: [2.71828] 2020ms

g++ -O:
int: [1587566083] 670ms
double: [2.71828] 680ms
*/	
	
