#include <iostream>
/*1: fuer sqrt, fabs*/
#include <cmath>

class Point {
/*2: x und y werden unten direkt benutzt*/
public:
	double x, y;
public:
	Point(double px /*3: ohne def. args kann man kein feld 
		von Point anlegen*/=0, double py/*3:*/=0) : 
		x(px)/*4: , statt ; */, y(py) /*5: Klammern fehlen */ {}
};

class Segment {
	/*6: Point* P = new Point[2]; geht so nicht*/
	Point P[2];
public:
	Segment (Point p1, Point p2)
	{
		P[/*7: felder ab 0 indizieren*/ 0]=p1;
		P[/*7: dito*/                   1]=p2;
	}

	/*8:kein return typ erlaubt */operator double (void)
	{
		double x=P[0].x-P[1].x,
		       y=P[0].y-P[1].y;
		
		/*9:retrun*/ return sqrt (((x*x + y*y)));
	}
}/*10: semikolon fehlt*/;


class /*11:t*/Triangle {
	Point P[3];
public:
	Triangle (Point A, Point B, Point C);

	operator double() /*12: wenn contains const dann hier auch*/ const {
		return /*13:abs ist integer betrag*/
			fabs ( 0.5 *
			/*14: - vor * */ (
				  (P[1].x-P[0].x)*(P[2].y-P[0].y)
				 -(P[1].y-P[0].y)*(P[2].x-P[0].x)
			/*14:*/ )
			   );
	}

	double area() /*15: weil contains const */ const /*16: klammer fehlt*/ {
		 return double(*this); 
	}
	
	bool contains (const Point&) const;
	
};

Triangle/*17: :: statt:*/::Triangle (Point p1, Point p2, Point p3)
{
	P[0]=p1; P[1]=p2; P[2]=p3;
}

bool Triangle::contains (const Point/*18: wie deklaration*/& p)/*19:*/const
{
	return  /*20: == in double fast unmoeglich*/
		fabs(
		Triangle(P[0], P[1], p)+
		Triangle(p, P[1], P[2])+
		Triangle(P[/*21:O*/0], p, P[2]) - area/*22: klammern*/()
		) < 0.0000001;
}

int main() { /* ein 3eck und 4 Testpunkte 23: Kommentarende */
	/*24: Typ fehlt*/
	Triangle* t = new Triangle(Point(0,0), Point (2, 0), Point(0,2));

	/*30: namespace std*/
	std::cout<<t/*25:.*/->contains (/*26:new*/ Point (1,1)/*27:klammer*/)<<endl;
	std::cout<<t/*25:.*/->contains (/*26:new*/ Point (2,2))<<endl;
	std::cout<<t/*25:.*/->contains (/*26:new*/ Point (.5, .5))<<endl;
	std::cout<<t/*25:.*/->contains (/*26:new*/ Point (/*28:1,*/1.0000001, 1))/*29:<*/<<endl;
}
	





	
