#include <iostream>

using namespace std;

class Pascal {
	int *p;
	int N;
public:
	Pascal(int n):N(n), p(new int[n])
	{
		if (n==1) { p[0]=1; return; }
		Pascal P(n-1);	
		cout<<" creating a Pascal ("<<N-1<<")\n";

		for (int i=0; i<N; ++i)
		{
			p[i]=P[i-1]+P[i];
		}
	}

	int operator[] (int i)const
	{
		if (i<0 || i>=N) return 0;
		return p[i];
	}
	int dim() const {return N;}

	friend ostream& operator << (ostream& o, const Pascal& p)
	{
		for (int i=0; i<p.dim(); ++i)
			o << p[i] << '\t';
		return o << endl;
	}
};


int main()
{

	Pascal p1(1);
	Pascal p2(2);
	Pascal p3(3);
	Pascal p4(4);
	Pascal p5(5);
	Pascal p6(6);

	Pascal p33(33);

	Pascal* Ps[]={&p1,&p2,&p3,&p4,&p5,&p6,&p33};

	for (int i=0; i<7; ++i) cout<<*Ps[i];

}	
